summaryrefslogtreecommitdiff
diff options
context:
space:
mode:
authorAssaf Gordon <assafgordon@gmail.com>2017-01-12 21:03:50 (GMT)
committerAssaf Gordon <assafgordon@gmail.com>2017-01-12 21:03:50 (GMT)
commitf48d4cdf05a0add71dacba7cc713c91cba072bcf (patch)
treef3240b602c173ff7962be7228f15cd567c26ee2b
parent833ec293858d40d7cf98d5b37c92fc642a241033 (diff)
downloadsavannah-tests-master.zip
savannah-tests-master.tar.gz
savannah-tests-master.tar.bz2
Override ssh options with a fake scriptHEADmasterfake-ssh
-rwxr-xr-xfake-ssh/generate-sv-known-hosts.sh53
-rw-r--r--fake-ssh/known_hosts.savannah28
-rwxr-xr-xfake-ssh/ssh55
-rw-r--r--test/Makefile.am8
4 files changed, 144 insertions, 0 deletions
diff --git a/fake-ssh/generate-sv-known-hosts.sh b/fake-ssh/generate-sv-known-hosts.sh
new file mode 100755
index 0000000..653261d
--- /dev/null
+++ b/fake-ssh/generate-sv-known-hosts.sh
@@ -0,0 +1,53 @@
+#!/bin/sh
+
+die()
+{
+ BASE=$(basename "$0")
+ echo "$BASE: error: $*" >&2
+ exit 1
+}
+
+
+DIR=$(dirname "$0")
+
+# Ensure we can find the correct directory,
+# where 'fake-ssh' is and where it expects to find 'known_hosts.savannah'.
+FAKESSH="$DIR/ssh"
+test -e "$FAKESSH" \
+ || die "'fake-ssh' not found in (expecting '$FAKESSH') " \
+ "- please run with path prefix".
+
+KNOWN="$DIR/known_hosts.savannah"
+
+# Truncate (or create) the file
+: > "$KNOWN" \
+ || die "failed to create/truncate '$KNOWN'"
+
+
+# NOTE:
+# It matters (indirectly) if the login succeeds or fails.
+# OpenSSH will add the host key regardless of login success/failure.
+# But too many failures will lead to your IP being blocked by fail2ban
+# which will ruin all the tests.
+SVUSER=${SVUSER:-sshtest}
+
+# Run 'fake-ssh' repeatedly for each of savannah's host names,
+# (ensuring it will update the known hosts file)
+# This needs to be done rarely - only when updating the acutal servers.
+
+export FAKE_SSH_NO_HOST_KEY_CHECK=1
+export FAKE_SSH_DEBUG=1
+
+list=
+for v in git hg cvs webcvs svn bzr dl download ; do
+ for s in savannah sv ; do
+ for g in gnu nongnu ; do
+ list="$list
+$v.$s.$g.org"
+ done
+ done
+done
+
+for l in $list ; do
+ "$FAKESSH" $SVUSER@$l uname
+done
diff --git a/fake-ssh/known_hosts.savannah b/fake-ssh/known_hosts.savannah
new file mode 100644
index 0000000..3f91f76
--- /dev/null
+++ b/fake-ssh/known_hosts.savannah
@@ -0,0 +1,28 @@
+git.savannah.gnu.org,208.118.235.72 ssh-rsa AAAAB3NzaC1yc2EAAAABIwAAAIEAzFQovi+67xa+wymRz9u3plx0ntQnELBoNU4SCl3RkwSFZkrZsRTC0fTpOKatQNs1r/BLFoVt21oVFwIXVevGQwB+Lf0Z+5w9qwVAQNu/YUAFHBPTqBze4wYK/gSWqQOLoj7rOhZk0xtAS6USqcfKdzMdRWgeuZ550P6gSzEHfv0=
+git.savannah.nongnu.org ssh-rsa AAAAB3NzaC1yc2EAAAABIwAAAIEAzFQovi+67xa+wymRz9u3plx0ntQnELBoNU4SCl3RkwSFZkrZsRTC0fTpOKatQNs1r/BLFoVt21oVFwIXVevGQwB+Lf0Z+5w9qwVAQNu/YUAFHBPTqBze4wYK/gSWqQOLoj7rOhZk0xtAS6USqcfKdzMdRWgeuZ550P6gSzEHfv0=
+git.sv.gnu.org ssh-rsa AAAAB3NzaC1yc2EAAAABIwAAAIEAzFQovi+67xa+wymRz9u3plx0ntQnELBoNU4SCl3RkwSFZkrZsRTC0fTpOKatQNs1r/BLFoVt21oVFwIXVevGQwB+Lf0Z+5w9qwVAQNu/YUAFHBPTqBze4wYK/gSWqQOLoj7rOhZk0xtAS6USqcfKdzMdRWgeuZ550P6gSzEHfv0=
+git.sv.nongnu.org ssh-rsa AAAAB3NzaC1yc2EAAAABIwAAAIEAzFQovi+67xa+wymRz9u3plx0ntQnELBoNU4SCl3RkwSFZkrZsRTC0fTpOKatQNs1r/BLFoVt21oVFwIXVevGQwB+Lf0Z+5w9qwVAQNu/YUAFHBPTqBze4wYK/gSWqQOLoj7rOhZk0xtAS6USqcfKdzMdRWgeuZ550P6gSzEHfv0=
+hg.savannah.gnu.org,208.118.235.201 ssh-rsa AAAAB3NzaC1yc2EAAAABIwAAAIEAzFQovi+67xa+wymRz9u3plx0ntQnELBoNU4SCl3RkwSFZkrZsRTC0fTpOKatQNs1r/BLFoVt21oVFwIXVevGQwB+Lf0Z+5w9qwVAQNu/YUAFHBPTqBze4wYK/gSWqQOLoj7rOhZk0xtAS6USqcfKdzMdRWgeuZ550P6gSzEHfv0=
+hg.savannah.nongnu.org ssh-rsa AAAAB3NzaC1yc2EAAAABIwAAAIEAzFQovi+67xa+wymRz9u3plx0ntQnELBoNU4SCl3RkwSFZkrZsRTC0fTpOKatQNs1r/BLFoVt21oVFwIXVevGQwB+Lf0Z+5w9qwVAQNu/YUAFHBPTqBze4wYK/gSWqQOLoj7rOhZk0xtAS6USqcfKdzMdRWgeuZ550P6gSzEHfv0=
+hg.sv.gnu.org ssh-rsa AAAAB3NzaC1yc2EAAAABIwAAAIEAzFQovi+67xa+wymRz9u3plx0ntQnELBoNU4SCl3RkwSFZkrZsRTC0fTpOKatQNs1r/BLFoVt21oVFwIXVevGQwB+Lf0Z+5w9qwVAQNu/YUAFHBPTqBze4wYK/gSWqQOLoj7rOhZk0xtAS6USqcfKdzMdRWgeuZ550P6gSzEHfv0=
+hg.sv.nongnu.org ssh-rsa AAAAB3NzaC1yc2EAAAABIwAAAIEAzFQovi+67xa+wymRz9u3plx0ntQnELBoNU4SCl3RkwSFZkrZsRTC0fTpOKatQNs1r/BLFoVt21oVFwIXVevGQwB+Lf0Z+5w9qwVAQNu/YUAFHBPTqBze4wYK/gSWqQOLoj7rOhZk0xtAS6USqcfKdzMdRWgeuZ550P6gSzEHfv0=
+cvs.savannah.gnu.org ssh-rsa AAAAB3NzaC1yc2EAAAABIwAAAIEAzFQovi+67xa+wymRz9u3plx0ntQnELBoNU4SCl3RkwSFZkrZsRTC0fTpOKatQNs1r/BLFoVt21oVFwIXVevGQwB+Lf0Z+5w9qwVAQNu/YUAFHBPTqBze4wYK/gSWqQOLoj7rOhZk0xtAS6USqcfKdzMdRWgeuZ550P6gSzEHfv0=
+cvs.savannah.nongnu.org ssh-rsa AAAAB3NzaC1yc2EAAAABIwAAAIEAzFQovi+67xa+wymRz9u3plx0ntQnELBoNU4SCl3RkwSFZkrZsRTC0fTpOKatQNs1r/BLFoVt21oVFwIXVevGQwB+Lf0Z+5w9qwVAQNu/YUAFHBPTqBze4wYK/gSWqQOLoj7rOhZk0xtAS6USqcfKdzMdRWgeuZ550P6gSzEHfv0=
+cvs.sv.gnu.org ssh-rsa AAAAB3NzaC1yc2EAAAABIwAAAIEAzFQovi+67xa+wymRz9u3plx0ntQnELBoNU4SCl3RkwSFZkrZsRTC0fTpOKatQNs1r/BLFoVt21oVFwIXVevGQwB+Lf0Z+5w9qwVAQNu/YUAFHBPTqBze4wYK/gSWqQOLoj7rOhZk0xtAS6USqcfKdzMdRWgeuZ550P6gSzEHfv0=
+cvs.sv.nongnu.org ssh-rsa AAAAB3NzaC1yc2EAAAABIwAAAIEAzFQovi+67xa+wymRz9u3plx0ntQnELBoNU4SCl3RkwSFZkrZsRTC0fTpOKatQNs1r/BLFoVt21oVFwIXVevGQwB+Lf0Z+5w9qwVAQNu/YUAFHBPTqBze4wYK/gSWqQOLoj7rOhZk0xtAS6USqcfKdzMdRWgeuZ550P6gSzEHfv0=
+svn.savannah.gnu.org ssh-rsa AAAAB3NzaC1yc2EAAAABIwAAAIEAzFQovi+67xa+wymRz9u3plx0ntQnELBoNU4SCl3RkwSFZkrZsRTC0fTpOKatQNs1r/BLFoVt21oVFwIXVevGQwB+Lf0Z+5w9qwVAQNu/YUAFHBPTqBze4wYK/gSWqQOLoj7rOhZk0xtAS6USqcfKdzMdRWgeuZ550P6gSzEHfv0=
+svn.savannah.nongnu.org ssh-rsa AAAAB3NzaC1yc2EAAAABIwAAAIEAzFQovi+67xa+wymRz9u3plx0ntQnELBoNU4SCl3RkwSFZkrZsRTC0fTpOKatQNs1r/BLFoVt21oVFwIXVevGQwB+Lf0Z+5w9qwVAQNu/YUAFHBPTqBze4wYK/gSWqQOLoj7rOhZk0xtAS6USqcfKdzMdRWgeuZ550P6gSzEHfv0=
+svn.sv.gnu.org ssh-rsa AAAAB3NzaC1yc2EAAAABIwAAAIEAzFQovi+67xa+wymRz9u3plx0ntQnELBoNU4SCl3RkwSFZkrZsRTC0fTpOKatQNs1r/BLFoVt21oVFwIXVevGQwB+Lf0Z+5w9qwVAQNu/YUAFHBPTqBze4wYK/gSWqQOLoj7rOhZk0xtAS6USqcfKdzMdRWgeuZ550P6gSzEHfv0=
+svn.sv.nongnu.org ssh-rsa AAAAB3NzaC1yc2EAAAABIwAAAIEAzFQovi+67xa+wymRz9u3plx0ntQnELBoNU4SCl3RkwSFZkrZsRTC0fTpOKatQNs1r/BLFoVt21oVFwIXVevGQwB+Lf0Z+5w9qwVAQNu/YUAFHBPTqBze4wYK/gSWqQOLoj7rOhZk0xtAS6USqcfKdzMdRWgeuZ550P6gSzEHfv0=
+bzr.savannah.gnu.org ssh-rsa AAAAB3NzaC1yc2EAAAABIwAAAIEAzFQovi+67xa+wymRz9u3plx0ntQnELBoNU4SCl3RkwSFZkrZsRTC0fTpOKatQNs1r/BLFoVt21oVFwIXVevGQwB+Lf0Z+5w9qwVAQNu/YUAFHBPTqBze4wYK/gSWqQOLoj7rOhZk0xtAS6USqcfKdzMdRWgeuZ550P6gSzEHfv0=
+bzr.savannah.nongnu.org ssh-rsa AAAAB3NzaC1yc2EAAAABIwAAAIEAzFQovi+67xa+wymRz9u3plx0ntQnELBoNU4SCl3RkwSFZkrZsRTC0fTpOKatQNs1r/BLFoVt21oVFwIXVevGQwB+Lf0Z+5w9qwVAQNu/YUAFHBPTqBze4wYK/gSWqQOLoj7rOhZk0xtAS6USqcfKdzMdRWgeuZ550P6gSzEHfv0=
+bzr.sv.gnu.org ssh-rsa AAAAB3NzaC1yc2EAAAABIwAAAIEAzFQovi+67xa+wymRz9u3plx0ntQnELBoNU4SCl3RkwSFZkrZsRTC0fTpOKatQNs1r/BLFoVt21oVFwIXVevGQwB+Lf0Z+5w9qwVAQNu/YUAFHBPTqBze4wYK/gSWqQOLoj7rOhZk0xtAS6USqcfKdzMdRWgeuZ550P6gSzEHfv0=
+bzr.sv.nongnu.org ssh-rsa AAAAB3NzaC1yc2EAAAABIwAAAIEAzFQovi+67xa+wymRz9u3plx0ntQnELBoNU4SCl3RkwSFZkrZsRTC0fTpOKatQNs1r/BLFoVt21oVFwIXVevGQwB+Lf0Z+5w9qwVAQNu/YUAFHBPTqBze4wYK/gSWqQOLoj7rOhZk0xtAS6USqcfKdzMdRWgeuZ550P6gSzEHfv0=
+dl.savannah.gnu.org,208.118.235.73 ssh-rsa AAAAB3NzaC1yc2EAAAABIwAAAIEAzFQovi+67xa+wymRz9u3plx0ntQnELBoNU4SCl3RkwSFZkrZsRTC0fTpOKatQNs1r/BLFoVt21oVFwIXVevGQwB+Lf0Z+5w9qwVAQNu/YUAFHBPTqBze4wYK/gSWqQOLoj7rOhZk0xtAS6USqcfKdzMdRWgeuZ550P6gSzEHfv0=
+dl.savannah.nongnu.org ssh-rsa AAAAB3NzaC1yc2EAAAABIwAAAIEAzFQovi+67xa+wymRz9u3plx0ntQnELBoNU4SCl3RkwSFZkrZsRTC0fTpOKatQNs1r/BLFoVt21oVFwIXVevGQwB+Lf0Z+5w9qwVAQNu/YUAFHBPTqBze4wYK/gSWqQOLoj7rOhZk0xtAS6USqcfKdzMdRWgeuZ550P6gSzEHfv0=
+dl.sv.gnu.org ssh-rsa AAAAB3NzaC1yc2EAAAABIwAAAIEAzFQovi+67xa+wymRz9u3plx0ntQnELBoNU4SCl3RkwSFZkrZsRTC0fTpOKatQNs1r/BLFoVt21oVFwIXVevGQwB+Lf0Z+5w9qwVAQNu/YUAFHBPTqBze4wYK/gSWqQOLoj7rOhZk0xtAS6USqcfKdzMdRWgeuZ550P6gSzEHfv0=
+dl.sv.nongnu.org ssh-rsa AAAAB3NzaC1yc2EAAAABIwAAAIEAzFQovi+67xa+wymRz9u3plx0ntQnELBoNU4SCl3RkwSFZkrZsRTC0fTpOKatQNs1r/BLFoVt21oVFwIXVevGQwB+Lf0Z+5w9qwVAQNu/YUAFHBPTqBze4wYK/gSWqQOLoj7rOhZk0xtAS6USqcfKdzMdRWgeuZ550P6gSzEHfv0=
+download.savannah.gnu.org ssh-rsa AAAAB3NzaC1yc2EAAAABIwAAAIEAzFQovi+67xa+wymRz9u3plx0ntQnELBoNU4SCl3RkwSFZkrZsRTC0fTpOKatQNs1r/BLFoVt21oVFwIXVevGQwB+Lf0Z+5w9qwVAQNu/YUAFHBPTqBze4wYK/gSWqQOLoj7rOhZk0xtAS6USqcfKdzMdRWgeuZ550P6gSzEHfv0=
+download.savannah.nongnu.org ssh-rsa AAAAB3NzaC1yc2EAAAABIwAAAIEAzFQovi+67xa+wymRz9u3plx0ntQnELBoNU4SCl3RkwSFZkrZsRTC0fTpOKatQNs1r/BLFoVt21oVFwIXVevGQwB+Lf0Z+5w9qwVAQNu/YUAFHBPTqBze4wYK/gSWqQOLoj7rOhZk0xtAS6USqcfKdzMdRWgeuZ550P6gSzEHfv0=
+download.sv.gnu.org ssh-rsa AAAAB3NzaC1yc2EAAAABIwAAAIEAzFQovi+67xa+wymRz9u3plx0ntQnELBoNU4SCl3RkwSFZkrZsRTC0fTpOKatQNs1r/BLFoVt21oVFwIXVevGQwB+Lf0Z+5w9qwVAQNu/YUAFHBPTqBze4wYK/gSWqQOLoj7rOhZk0xtAS6USqcfKdzMdRWgeuZ550P6gSzEHfv0=
+download.sv.nongnu.org ssh-rsa AAAAB3NzaC1yc2EAAAABIwAAAIEAzFQovi+67xa+wymRz9u3plx0ntQnELBoNU4SCl3RkwSFZkrZsRTC0fTpOKatQNs1r/BLFoVt21oVFwIXVevGQwB+Lf0Z+5w9qwVAQNu/YUAFHBPTqBze4wYK/gSWqQOLoj7rOhZk0xtAS6USqcfKdzMdRWgeuZ550P6gSzEHfv0=
diff --git a/fake-ssh/ssh b/fake-ssh/ssh
new file mode 100755
index 0000000..c85ad53
--- /dev/null
+++ b/fake-ssh/ssh
@@ -0,0 +1,55 @@
+#!/bin/sh
+
+## Run SSH without worrying about host finger prints.
+## Note: this assumes OpenSSH, and GNU find/xargs
+
+die()
+{
+ BASE=$(basename "$0")
+ echo "$BASE: error: $*" >&2
+ exit 1
+}
+
+## Enable strict host key check by default -
+## if something changed, ssh will block the connection.
+##
+## If FAKE_SSH_NO_HOST_KEY_CHECK is non-empty,
+## disable the key check.
+## This allows regenerating/updating the known_hosts file.
+strict_host_key_check=yes
+test "$FAKE_SSH_NO_HOST_KEY_CHECK" \
+ && strict_host_key_check=no
+
+
+## This assumes we're the first on the search $PATH
+SELF=$(which ssh)
+
+DIR=$(dirname "$SELF")
+KNOWN="$DIR/known_hosts.savannah"
+test -e "$KNOWN" \
+ || die "savannah's fixed knownhosts file ($KNOWN) not found"
+
+
+## Find the next ssh file which isn't us.
+NEXT=$(printf "%s" "$PATH" \
+ | tr ':' '\0' \
+ | xargs -0 -I% find '%' -maxdepth 1 -name 'ssh' -type f 2>/dev/null \
+ | grep -v -F "$SELF" \
+ | head -n 1)
+
+test -x "$NEXT" \
+ || die "can't find next ssh in \$PATH"
+
+
+if test "$FAKE_SSH_DEBUG" ; then
+ echo "fake-ssh: next ssh = $NEXT" >&2
+ echo "fake-ssh: knownhosts = $KNOWN" >&2
+fi
+
+
+exec "$NEXT" -o StrictHostKeyChecking=$strict_host_key_check \
+ -o CheckHostIP=yes \
+ -o HashKnownHosts=no \
+ -o PasswordAuthentication=no \
+ -o HostKeyAlgorithms=ssh-rsa \
+ -o "UserKnownHostsFile=$KNOWN" "$@"
diff --git a/test/Makefile.am b/test/Makefile.am
index f064071..893aaf9 100644
--- a/test/Makefile.am
+++ b/test/Makefile.am
@@ -8,3 +8,11 @@ TESTS = \
XFAIL_TESTS = git-https
EXTRA_DIST = $(TESTS)
+
+
+# Add the fake 'ssh' script at the top of the $PATH.
+# It forces certain SSH parameters,
+# and all ssh connections (e.g. hg/bzr/cvs/git/svn) will use it
+# automatically.
+TESTS_ENVIRONMENT=\
+ PATH='$(abs_top_srcdir)/fake-ssh:$(PATH_SEPARATOR)'$$PATH